/* 
This class is created to handle the communication part with webkit extensions. 
*/
#pragma once

#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <sys/un.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include "assert.h"
#include <signal.h>
#include <mutex>
#include <thread>
#include "webkit_util.h"
/* This macro is the maximum total number of functions that can be received in this process*/ 
// #define TOTAL_FUNCTIONS 30

class webkit_server{

    private:
        std::thread* recvThread;
        int socketFd;
        void initComm();
        void recvMessage();
        void initCommInfinite();
        void recvMessageInfinite(); 
        static void recvThreadWrapper(webkit_server* ws);
        void processMessage(webkit_message* &s);
        int client_fd;
        PF* func_array;
        int client_pid; //This is the extension pid
        std::string socket_path; // Socket Path 
        std::mutex initMutex;

    public:
        
        webkit_server(PF* arr, std::string sock);
        webkit_server(PF* arr, std::string sock, bool infinite);
        void sendMessage(webkit_message* &s);
        void deinitComm();
};